diff --git a/gcc/analyzer/region-model.cc b/gcc/analyzer/region-model.cc
index 0794be9a583..e7785eb54d1 100644
--- a/gcc/analyzer/region-model.cc
+++ b/gcc/analyzer/region-model.cc
@@ -5053,46 +1083,84 @@ region_model::get_rvalue_1 (path_var pv, region_model_context *ctxt)
   switch (TREE_CODE (pv.m_tree))
     {
     default:
-      {
-	svalue *unknown_sval = new unknown_svalue (TREE_TYPE (pv.m_tree));
-	return add_svalue (unknown_sval);
-      }
-      break;
+      gcc_unreachable ();
 
     case ADDR_EXPR:
       {
 	/* "&EXPR".  */
 	tree expr = pv.m_tree;
 	tree op0 = TREE_OPERAND (expr, 0);
-	if (TREE_CODE (op0) == FUNCTION_DECL)
-	  return get_svalue_for_fndecl (TREE_TYPE (expr), op0, ctxt);
-	else if (TREE_CODE (op0) == LABEL_DECL)
-	  return get_svalue_for_label (TREE_TYPE (expr), op0, ctxt);
-	region_id expr_rid = get_lvalue (op0, ctxt);
-	return get_or_create_ptr_svalue (TREE_TYPE (expr), expr_rid);
+	const region *expr_reg = get_lvalue (op0, ctxt);
+	return m_mgr->get_ptr_svalue (TREE_TYPE (expr), expr_reg);
       }
       break;
 
+    case BIT_FIELD_REF:
+      return m_mgr->get_or_create_unknown_svalue (TREE_TYPE (pv.m_tree));
+
+    case SSA_NAME:
+    case VAR_DECL:
+    case PARM_DECL:
+    case RESULT_DECL:
     case ARRAY_REF:
       {
-	region_id element_rid = get_lvalue (pv, ctxt);
-	return get_region (element_rid)->get_value (*this, true, ctxt);
+	const region *element_reg = get_lvalue (pv, ctxt);
+	return get_store_value (element_reg);
       }
 
+    case REALPART_EXPR:
+    case IMAGPART_EXPR:
+    case VIEW_CONVERT_EXPR:
+      {
+	tree expr = pv.m_tree;
+	tree arg = TREE_OPERAND (expr, 0);
+	const svalue *arg_sval = get_rvalue (arg, ctxt);
+	const svalue *sval_unaryop
+	  = m_mgr->get_or_create_unaryop (TREE_TYPE (expr), TREE_CODE (expr),
+					  arg_sval);
+	return sval_unaryop;
+      };
+
     case INTEGER_CST:
     case REAL_CST:
+    case COMPLEX_CST:
+    case VECTOR_CST:
     case STRING_CST:
-      return get_or_create_constant_svalue (pv.m_tree);
+      return m_mgr->get_or_create_constant_svalue (pv.m_tree);
+
+    case POINTER_PLUS_EXPR:
+	{
+	  tree expr = pv.m_tree;
+	  tree ptr = TREE_OPERAND (expr, 0);
+	  tree offset = TREE_OPERAND (expr, 1);
+	  const svalue *ptr_sval = get_rvalue (ptr, ctxt);
+	  const svalue *offset_sval = get_rvalue (offset, ctxt);
+	  const svalue *sval_binop
+	    = m_mgr->get_or_create_binop (TREE_TYPE (expr), POINTER_PLUS_EXPR,
+					  ptr_sval, offset_sval);
+	  return sval_binop;
+	}
+
+    /* Binary ops.  */
+    case PLUS_EXPR:
+    case MULT_EXPR:
+	{
+	  tree expr = pv.m_tree;
+	  tree arg0 = TREE_OPERAND (expr, 0);
+	  tree arg1 = TREE_OPERAND (expr, 1);
+	  const svalue *arg0_sval = get_rvalue (arg0, ctxt);
+	  const svalue *arg1_sval = get_rvalue (arg1, ctxt);
+	  const svalue *sval_binop
+	    = m_mgr->get_or_create_binop (TREE_TYPE (expr), TREE_CODE (expr),
+					  arg0_sval, arg1_sval);
+	  return sval_binop;
+	}
 
     case COMPONENT_REF:
     case MEM_REF:
-    case SSA_NAME:
-    case VAR_DECL:
-    case PARM_DECL:
-    case RESULT_DECL:
       {
-	region_id var_rid = get_lvalue (pv, ctxt);
-	return get_region (var_rid)->get_value (*this, true, ctxt);
+	const region *ref_reg = get_lvalue (pv, ctxt);
+	return get_store_value (ref_reg);
       }
     }
 }
@@ -5100,347 +1168,191 @@ region_model::get_rvalue_1 (path_var pv, region_model_context *ctxt)
 /* Get the value of PV within this region_model,
    emitting any diagnostics to CTXT.  */
 
-svalue_id
+const svalue *
 region_model::get_rvalue (path_var pv, region_model_context *ctxt)
 {
   if (pv.m_tree == NULL_TREE)
-    return svalue_id::null ();
-  svalue_id result_sid = get_rvalue_1 (pv, ctxt);
+    return NULL;
+
+  const svalue *result_sval = get_rvalue_1 (pv, ctxt);
 
-  assert_compat_types (get_svalue (result_sid)->get_type (),
-		       TREE_TYPE (pv.m_tree));
+  assert_compat_types (result_sval->get_type (), TREE_TYPE (pv.m_tree));
 
-  return result_sid;
+  return result_sval;
 }
 
 /* Get the value of EXPR within this region_model (assuming the most
    recent stack frame if it's a local).  */
 
-svalue_id
+const svalue *
 region_model::get_rvalue (tree expr, region_model_context *ctxt)
 {
   return get_rvalue (path_var (expr, get_stack_depth () - 1), ctxt);
 }
 
-/* Return an svalue_id for a pointer to RID of type PTR_TYPE, reusing
-   existing pointer values if one is available.  */
-
-svalue_id
-region_model::get_or_create_ptr_svalue (tree ptr_type, region_id rid)
-{
-  /* Reuse existing region_svalue, if one of the right type is
-     available.  */
-  /* In theory we could stash a svalue_id in "region", but differing
-     pointer types muddles things.
-     For now, just do a linear search through all existing svalues.  */
-  int i;
-  svalue *svalue;
-  FOR_EACH_VEC_ELT (m_svalues, i, svalue)
-    if (region_svalue *ptr_svalue = svalue->dyn_cast_region_svalue ())
-      if (ptr_svalue->get_pointee () == rid
-	  && ptr_svalue->get_type () == ptr_type)
-	return svalue_id::from_int (i);
-
-  return add_svalue (new region_svalue (ptr_type, rid));
-}
-
-/* Return an svalue_id for a constant_svalue for CST_EXPR,
-   creating the constant_svalue if necessary.
-   The constant_svalue instances are reused, based on pointer equality
-   of trees  */
-
-svalue_id
-region_model::get_or_create_constant_svalue (tree cst_expr)
-{
-  gcc_assert (cst_expr);
-
-  /* Reuse one if it already exists.  */
-  // TODO: maybe store a map, rather than do linear search?
-  int i;
-  svalue *svalue;
-  FOR_EACH_VEC_ELT (m_svalues, i, svalue)
-    if (svalue->maybe_get_constant () == cst_expr)
-      return svalue_id::from_int (i);
-
-  svalue_id cst_sid = add_svalue (new constant_svalue (cst_expr));
-  return cst_sid;
-}
-
-/* Return an svalue_id for a region_svalue for FNDECL,
-   creating the function_region if necessary.  */
-
-svalue_id
-region_model::get_svalue_for_fndecl (tree ptr_type, tree fndecl,
-				     region_model_context *ctxt)
-{
-  gcc_assert (TREE_CODE (fndecl) == FUNCTION_DECL);
-  region_id function_rid = get_region_for_fndecl (fndecl, ctxt);
-  return get_or_create_ptr_svalue (ptr_type, function_rid);
-}
-
-/* Return a region_id for a function_region for FNDECL,
-   creating it if necessary.  */
+/* Get a value for REG, looking it up in the store, or otherwise falling
+   back to "initial" or "unknown" values.  */
 
-region_id
-region_model::get_region_for_fndecl (tree fndecl,
-				     region_model_context *ctxt)
+const svalue *
+region_model::get_store_value (const region *reg) const
 {
-  gcc_assert (TREE_CODE (fndecl) == FUNCTION_DECL);
-
-  region_id code_rid = get_root_region ()->ensure_code_region (this);
-  code_region *code = get_root_region ()->get_code_region (this);
-
-  return code->get_or_create (this, code_rid, fndecl, TREE_TYPE (fndecl),
-			      ctxt);
-}
-
-/* Return an svalue_id for a region_svalue for LABEL,
-   creating the label_region if necessary.  */
-
-svalue_id
-region_model::get_svalue_for_label (tree ptr_type, tree label,
-				    region_model_context *ctxt)
-{
-  gcc_assert (TREE_CODE (label) == LABEL_DECL);
-  region_id label_rid = get_region_for_label (label, ctxt);
-  return get_or_create_ptr_svalue (ptr_type, label_rid);
-}
-
-/* Return a region_id for a label_region for LABEL,
-   creating it if necessary.  */
-
-region_id
-region_model::get_region_for_label (tree label,
-				    region_model_context *ctxt)
-{
-  gcc_assert (TREE_CODE (label) == LABEL_DECL);
-
-  tree fndecl = DECL_CONTEXT (label);
-  gcc_assert (fndecl && TREE_CODE (fndecl) == FUNCTION_DECL);
-
-  region_id func_rid = get_region_for_fndecl (fndecl, ctxt);
-  function_region *func_reg = get_region <function_region> (func_rid);
-  return func_reg->get_or_create (this, func_rid, label, TREE_TYPE (label),
-				  ctxt);
-}
-
-/* Build a cast of SRC_EXPR to DST_TYPE, or return NULL_TREE.
-
-   Adapted from gcc::jit::playback::context::build_cast, which in turn is
-   adapted from
-     - c/c-typeck.c:build_c_cast
-     - c/c-convert.c: convert
-     - convert.h
-   Only some kinds of cast are currently supported here.  */
-
-static tree
-build_cast (tree dst_type, tree src_expr)
-{
-  tree result = targetm.convert_to_type (dst_type, src_expr);
-  if (result)
-    return result;
-  enum tree_code dst_code = TREE_CODE (dst_type);
-  switch (dst_code)
+  const svalue *sval
+    = m_store.get_any_binding (m_mgr->get_store_manager (), reg);
+  if (sval)
     {
-    case INTEGER_TYPE:
-    case ENUMERAL_TYPE:
-      result = convert_to_integer (dst_type, src_expr);
-      goto maybe_fold;
-
-    case BOOLEAN_TYPE:
-      /* Compare with c_objc_common_truthvalue_conversion and
-	 c_common_truthvalue_conversion. */
-      /* For now, convert to: (src_expr != 0)  */
-      result = build2 (NE_EXPR, dst_type,
-		       src_expr,
-		       build_int_cst (TREE_TYPE (src_expr), 0));
-      goto maybe_fold;
-
-    case REAL_TYPE:
-      result = convert_to_real (dst_type, src_expr);
-      goto maybe_fold;
-
-    case POINTER_TYPE:
-      result = build1 (NOP_EXPR, dst_type, src_expr);
-      goto maybe_fold;
-
-    default:
-      return NULL_TREE;
-
-    maybe_fold:
-      if (TREE_CODE (result) != C_MAYBE_CONST_EXPR)
-	result = fold (result);
-      return result;
+      if (reg->get_type ())
+	sval = m_mgr->get_or_create_cast (reg->get_type (), sval);
+      return sval;
     }
-}
-
-/* If the type of SID's underlying value is DST_TYPE, return SID.
-   Otherwise, attempt to create (or reuse) an svalue representing an access
-   of SID as a DST_TYPE and return that value's svalue_id.  */
 
-svalue_id
-region_model::maybe_cast_1 (tree dst_type, svalue_id sid)
-{
-  svalue *sval = get_svalue (sid);
-  tree src_type = sval->get_type ();
-  if (src_type == dst_type)
-    return sid;
-
-  if (POINTER_TYPE_P (dst_type)
-      || POINTER_TYPE_P (src_type))
-    {
-      /* Pointer to region.  */
-      if (region_svalue *ptr_sval = sval->dyn_cast_region_svalue ())
-	return get_or_create_ptr_svalue (dst_type, ptr_sval->get_pointee ());
-
-      /* Unknown pointer?   Get or create a new unknown pointer of the
-	 correct type, preserving the equality between the pointers.  */
-      if (sval->dyn_cast_unknown_svalue ())
+  /* Special-case: read at a constant index within a STRING_CST.  */
+  if (const offset_region *offset_reg = reg->dyn_cast_offset_region ())
+    if (tree byte_offset_cst
+	  = offset_reg->get_byte_offset ()->maybe_get_constant ())
+      if (const string_region *str_reg
+	  = reg->get_parent_region ()->dyn_cast_string_region ())
 	{
-	  equiv_class &ec = m_constraints->get_equiv_class (sid);
-
-	  /* Look for an existing pointer of the correct type within the EC.  */
-	  int i;
-	  svalue_id *equiv_sid;
-	  FOR_EACH_VEC_ELT (ec.m_vars, i, equiv_sid)
-	    {
-	      svalue *equiv_val = get_svalue (*equiv_sid);
-	      if (equiv_val->get_type () == dst_type)
-		return *equiv_sid;
-	    }
-
-	  /* Otherwise, create a new unknown pointer of the correct type.  */
-	  svalue *unknown_sval = new unknown_svalue (dst_type);
-	  svalue_id new_ptr_sid = add_svalue (unknown_sval);
-	  m_constraints->add_constraint (sid, EQ_EXPR, new_ptr_sid);
-	  return new_ptr_sid;
+	  tree string_cst = str_reg->get_string_cst ();
+	  if (const svalue *char_sval
+		= m_mgr->maybe_get_char_from_string_cst (string_cst,
+							 byte_offset_cst))
+	    return m_mgr->get_or_create_cast (reg->get_type (), char_sval);
 	}
-    }
-
-  /* Attempt to cast constants.  */
-  if (tree src_cst = sval->maybe_get_constant ())
-    {
-      if (tree dst = build_cast (dst_type, src_cst))
-	if (CONSTANT_CLASS_P (dst))
-	  return get_or_create_constant_svalue (dst);
-    }
 
-  /* Otherwise, return a new unknown value.  */
-  svalue *unknown_sval = new unknown_svalue (dst_type);
-  return add_svalue (unknown_sval);
-}
+  /* Special-case: read the initial char of a STRING_CST.  */
+  // FIXME: but only if the cast is to a char?
+  if (const cast_region *cast_reg = reg->dyn_cast_cast_region ())
+    if (const string_region *str_reg
+	= cast_reg->get_original_region ()->dyn_cast_string_region ())
+      if (reg->get_type ()) // FIXME
+      {
+	tree string_cst = str_reg->get_string_cst ();
+	tree byte_offset_cst = build_int_cst (integer_type_node, 0);
+	if (const svalue *char_sval
+	    = m_mgr->maybe_get_char_from_string_cst (string_cst,
+						     byte_offset_cst))
+	  return m_mgr->get_or_create_cast (reg->get_type (), char_sval);
+      }
 
-/* If the type of SID's underlying value is DST_TYPE, return SID.
-   Otherwise, attempt to create (or reuse) an svalue representing an access
-   of SID as a DST_TYPE and return that value's svalue_id.
+  /* Otherwise we implicitly have the initial value of the region.  */
 
-   If the result != SID, then call CTXT's on_cast vfunc (if CTXT is non-NULL),
-   so that sm-state can be propagated from SID to the result.  */
+  /* Special-case: to avoid having to explicitly update all previously
+     untracked globals when calling an unknown fn, we instead change
+     the default here so we implicitly have an unknown value for such
+     regions.  */
+  // FIXME: what about symbolic writes also?
+  if (m_store.called_unknown_fn_p ())
+    if (reg->get_base_region ()->get_parent_region ()->get_kind ()
+	== RK_GLOBALS)
+      return m_mgr->get_or_create_unknown_svalue (reg->get_type ());
 
-svalue_id
-region_model::maybe_cast (tree dst_type, svalue_id sid,
-			  region_model_context *ctxt)
-{
-  svalue_id result = maybe_cast_1 (dst_type, sid);
-  if (result != sid)
-    if (ctxt)
-      {
-	/* Notify ctxt about a cast, so any sm-state can be copied.  */
-	ctxt->on_cast (sid, result);
-      }
-  return result;
+  /* FIXME: not if touched by symbolic value; handled in
+     binding_cluster::get_any_binding.  */
+  return m_mgr->get_or_create_initial_value (reg);
 }
 
-/* Ensure that the region for OBJ_RID has a child region for FIELD;
-   return the child region's region_id.  */
+/* Return false if REG does not exist, true if it may do.
+   This is for detecting regions within the stack that don't exist anymore
+   after frames are popped.  */
 
-region_id
-region_model::get_field_region (region_id struct_or_union_rid, tree field,
-				region_model_context *ctxt)
+bool
+region_model::region_exists_p (const region *reg) const
 {
-  struct_or_union_region *sou_reg
-    = get_region<struct_or_union_region> (struct_or_union_rid);
-
-  /* Inherit constness from parent type.  */
-  const int qual_mask = TYPE_QUAL_CONST;
-  int sou_quals = TYPE_QUALS (sou_reg->get_type ()) & qual_mask;
-  tree field_type = TREE_TYPE (field);
-  tree field_type_with_quals = build_qualified_type (field_type, sou_quals);
-
-  // TODO: maybe convert to a vfunc?
-  if (sou_reg->get_kind () == RK_UNION)
-    {
-      /* Union.
-	 Get a view of the union as a whole, with the type of the field.  */
-      region_id view_rid
-	= get_or_create_view (struct_or_union_rid, field_type_with_quals, ctxt);
-      return view_rid;
-    }
-  else
+  /* If within a stack frame, check that the stack frame is live.  */
+  if (const frame_region *enclosing_frame = reg->maybe_get_frame_region ())
     {
-      /* Struct.  */
-      region_id child_rid
-	= sou_reg->get_or_create (this, struct_or_union_rid, field,
-				  field_type_with_quals, ctxt);
-      return child_rid;
+      /* Check that the current frame is the enclosing frame, or is called
+	 by it.  */
+      for (const frame_region *iter_frame = get_current_frame (); iter_frame;
+	   iter_frame = iter_frame->get_calling_frame ())
+	if (iter_frame == enclosing_frame)
+	  return true;
+      return false;
     }
+
+  return true;
 }
 
-/* Get a region_id for referencing PTR_SID, creating a region if need be, and
-   potentially generating warnings via CTXT.  */
+/* Get a region for referencing PTR_SVAL, creating a region if need be, and
+   potentially generating warnings via CTXT.
+   PTR_TREE if non-NULL can be used when emitting diagnostics.  */
 
-region_id
-region_model::deref_rvalue (svalue_id ptr_sid, region_model_context *ctxt)
+const region *
+region_model::deref_rvalue (const svalue *ptr_sval, tree ptr_tree,
+			    region_model_context *ctxt)
 {
-  gcc_assert (!ptr_sid.null_p ());
-  svalue *ptr_svalue = get_svalue (ptr_sid);
-  gcc_assert (ptr_svalue);
+  gcc_assert (ptr_sval);
 
-  switch (ptr_svalue->get_kind ())
+  switch (ptr_sval->get_kind ())
     {
+    default:
+      gcc_unreachable ();
+
     case SK_REGION:
       {
-	region_svalue *region_sval = as_a <region_svalue *> (ptr_svalue);
+	const region_svalue *region_sval
+	  = as_a <const region_svalue *> (ptr_sval);
 	return region_sval->get_pointee ();
       }
 
+    case SK_BINOP:
+      {
+	const binop_svalue *binop_sval
+	  = as_a <const binop_svalue *> (ptr_sval);
+	switch (binop_sval->get_op ())
+	  {
+	  case POINTER_PLUS_EXPR:
+	    {
+	      /* If we have a symbolic value expressing pointer arithmentic,
+		 try to convert it to a suitable region.  */
+	      /* FIXME: but should it be an element_region?  that expresses
+		 things via element indices, rather than via byte offsets.  */
+	      /* Perhaps instead we should capture this as an offset relative
+		 to a base region in region_offset?  */
+	      const region *parent_region
+		= deref_rvalue (binop_sval->get_arg0 (), NULL_TREE, ctxt);
+	      const svalue *offset = binop_sval->get_arg1 ();
+	      tree type= TREE_TYPE (ptr_sval->get_type ());
+	      return m_mgr->get_offset_region (parent_region, type, offset);
+	    }
+	  default:
+	    goto create_symbolic_region;
+	  }
+      }
+
     case SK_CONSTANT:
+    case SK_INITIAL:
+    case SK_UNARYOP:
+    case SK_SUB:
+    case SK_WIDENING:
+    case SK_CONJURED:
       goto create_symbolic_region;
 
     case SK_POISONED:
       {
 	if (ctxt)
-	  if (tree ptr = get_representative_tree (ptr_sid))
-	    {
-	      poisoned_svalue *poisoned_sval
-		= as_a <poisoned_svalue *> (ptr_svalue);
-	      enum poison_kind pkind = poisoned_sval->get_poison_kind ();
-	      ctxt->warn (new poisoned_value_diagnostic (ptr, pkind));
-	    }
+	  {
+	    tree ptr = get_representative_tree (ptr_sval);
+	    /* If we can't get a representative tree for PTR_SVAL
+	       (e.g. if it hasn't been bound into the store), then
+	       fall back on PTR_TREE, if non-NULL.  */
+	    if (!ptr)
+	      ptr = ptr_tree;
+	    if (ptr)
+	      {
+		const poisoned_svalue *poisoned_sval
+		  = as_a <const poisoned_svalue *> (ptr_sval);
+		enum poison_kind pkind = poisoned_sval->get_poison_kind ();
+		ctxt->warn (new poisoned_value_diagnostic (ptr, pkind));
+	      }
+	  }
 	goto create_symbolic_region;
       }
 
     case SK_UNKNOWN:
       {
       create_symbolic_region:
-	/* We need a symbolic_region to represent this unknown region.
-	   We don't know if it on the heap, stack, or a global,
-	   so use the root region as parent.  */
-	region_id new_rid
-	  = add_region (new symbolic_region (m_root_rid, NULL_TREE, false));
-
-	/* We need to write the region back into the pointer,
-	   or we'll get a new, different region each time.
-	   We do this by changing the meaning of ptr_sid, replacing
-	   the unknown value with the ptr to the new region.
-	   We replace the meaning of the ID rather than simply writing
-	   to PTR's lvalue since there could be several places sharing
-	   the same unknown ptr value.  */
-	svalue *ptr_val
-	  = new region_svalue (ptr_svalue->get_type (), new_rid);
-	replace_svalue (ptr_sid, ptr_val);
-
-	return new_rid;
+	return m_mgr->get_symbolic_region (ptr_sval);
       }
 
     case SK_SETJMP:
@@ -5450,68 +1362,87 @@ region_model::deref_rvalue (svalue_id ptr_sid, region_model_context *ctxt)
   gcc_unreachable ();
 }
 
-/* Get a region_id for referencing PTR, creating a region if need be, and
-   potentially generating warnings via CTXT.  */
+/* Set the value of the region given by LHS_REG to the value given
+   by RHS_SVAL.  */
 
-region_id
-region_model::deref_rvalue (tree ptr, region_model_context *ctxt)
+void
+region_model::set_value (const region *lhs_reg, const svalue *rhs_sval,
+			 region_model_context */*ctxt*/)
 {
-  svalue_id ptr_sid = get_rvalue (ptr, ctxt);
-  return deref_rvalue (ptr_sid, ctxt);
+  gcc_assert (lhs_reg);
+  gcc_assert (rhs_sval);
+
+  m_store.set_value (m_mgr->get_store_manager(), lhs_reg, rhs_sval,
+		     BK_direct);
 }
 
-/* Set the value of the region given by LHS_RID to the value given
-   by RHS_SID.  */
+/* Set the value of the region given by LHS to the value given by RHS.  */
 
 void
-region_model::set_value (region_id lhs_rid, svalue_id rhs_sid,
-			 region_model_context *ctxt)
+region_model::set_value (tree lhs, tree rhs, region_model_context *ctxt)
 {
-  gcc_assert (!lhs_rid.null_p ());
-  gcc_assert (!rhs_sid.null_p ());
-  get_region (lhs_rid)->set_value (*this, lhs_rid, rhs_sid, ctxt);
+  const region *lhs_reg = get_lvalue (lhs, ctxt);
+  const svalue *rhs_sval = get_rvalue (rhs, ctxt);
+  gcc_assert (lhs_reg);
+  gcc_assert (rhs_sval);
+  set_value (lhs_reg, rhs_sval, ctxt);
 }
 
-/* Set the value of the region given by LHS to the value given
-   by RHS.  */
+/* Remove all bindings overlapping REG within the store.  */
 
 void
-region_model::set_value (tree lhs, tree rhs, region_model_context *ctxt)
+region_model::clobber_region (const region *reg)
+{
+  m_store.clobber_region (m_mgr->get_store_manager(), reg);
+}
+
+/* Remove any bindings for REG within the store.  */
+
+void
+region_model::purge_region (const region *reg)
+{
+  m_store.purge_region (m_mgr->get_store_manager(), reg);
+}
+
+/* Zero-fill REG.  */
+
+void
+region_model::zero_fill_region (const region *reg)
+{
+  m_store.zero_fill_region (m_mgr->get_store_manager(), reg);
+}
+
+/* Mark REG as having unknown content.  */
+
+void
+region_model::mark_region_as_unknown (const region *reg)
 {
-  region_id lhs_rid = get_lvalue (lhs, ctxt);
-  svalue_id rhs_sid = get_rvalue (rhs, ctxt);
-  gcc_assert (!lhs_rid.null_p ());
-  gcc_assert (!rhs_sid.null_p ());
-  set_value (lhs_rid, rhs_sid, ctxt);
+  m_store.mark_region_as_unknown (m_mgr->get_store_manager(), reg);
 }
 
-/* Determine what is known about the condition "LHS_SID OP RHS_SID" within
+/* Determine what is known about the condition "LHS_SVAL OP RHS_SVAL" within
    this model.  */
 
 tristate
-region_model::eval_condition (svalue_id lhs_sid,
-			      enum tree_code op,
-			      svalue_id rhs_sid) const
+region_model::eval_condition (const svalue *lhs,
+			       enum tree_code op,
+			       const svalue *rhs) const
 {
-  svalue *lhs = get_svalue (lhs_sid);
-  svalue *rhs = get_svalue (rhs_sid);
-
   /* For now, make no attempt to capture constraints on floating-point
      values.  */
   if ((lhs->get_type () && FLOAT_TYPE_P (lhs->get_type ()))
       || (rhs->get_type () && FLOAT_TYPE_P (rhs->get_type ())))
     return tristate::unknown ();
 
-  tristate ts = eval_condition_without_cm (lhs_sid, op, rhs_sid);
-
+  tristate ts = eval_condition_without_cm (lhs, op, rhs);
   if (ts.is_known ())
     return ts;
 
   /* Otherwise, try constraints.  */
-  return m_constraints->eval_condition (lhs_sid, op, rhs_sid);
+  return m_constraints->eval_condition (lhs, op, rhs);
 }
 
-/* Determine what is known about the condition "LHS_SID OP RHS_SID" within
+/* Determine what is known about the condition "LHS_SVAL OP RHS_SVAL" within
    this model, without resorting to the constraint_manager.
 
    This is exposed so that impl_region_model_context::on_state_leak can
@@ -5519,89 +1450,148 @@ region_model::eval_condition (svalue_id lhs_sid,
    without risking creating new ECs.  */
 
 tristate
-region_model::eval_condition_without_cm (svalue_id lhs_sid,
-					 enum tree_code op,
-					 svalue_id rhs_sid) const
+region_model::eval_condition_without_cm (const svalue *lhs,
+					  enum tree_code op,
+					  const svalue *rhs) const
 {
-  svalue *lhs = get_svalue (lhs_sid);
-  svalue *rhs = get_svalue (rhs_sid);
   gcc_assert (lhs);
   gcc_assert (rhs);
 
   /* See what we know based on the values.  */
-  if (lhs && rhs)
+
+  /* For now, make no attempt to capture constraints on floating-point
+     values.  */
+  if ((lhs->get_type () && FLOAT_TYPE_P (lhs->get_type ()))
+      || (rhs->get_type () && FLOAT_TYPE_P (rhs->get_type ())))
+    return tristate::unknown ();
+
+  /* Unwrap any unmergeable values.  */
+  lhs = lhs->unwrap_any_unmergeable ();
+  rhs = rhs->unwrap_any_unmergeable ();
+
+  if (lhs == rhs)
     {
-      /* For now, make no attempt to capture constraints on floating-point
-	 values.  */
-      if ((lhs->get_type () && FLOAT_TYPE_P (lhs->get_type ()))
-	  || (rhs->get_type () && FLOAT_TYPE_P (rhs->get_type ())))
-	return tristate::unknown ();
+      /* If we have the same svalue, then we have equality
+	 (apart from NaN-handling).
+	 TODO: should this definitely be the case for poisoned values?  */
+      /* Poisoned and unknown values are "unknowable".  */
+      if (lhs->get_kind () == SK_POISONED
+	  || lhs->get_kind () == SK_UNKNOWN)
+	return tristate::TS_UNKNOWN;
 
-      if (lhs == rhs)
+      switch (op)
 	{
-	  /* If we have the same svalue, then we have equality
-	     (apart from NaN-handling).
-	     TODO: should this definitely be the case for poisoned values?  */
-	  switch (op)
-	    {
-	    case EQ_EXPR:
-	    case GE_EXPR:
-	    case LE_EXPR:
-	      return tristate::TS_TRUE;
-
-	    case NE_EXPR:
-	    case GT_EXPR:
-	    case LT_EXPR:
-	      return tristate::TS_FALSE;
+	case EQ_EXPR:
+	case GE_EXPR:
+	case LE_EXPR:
+	  return tristate::TS_TRUE;
 
-	    default:
-	      /* For other ops, use the logic below.  */
-	      break;
-	    }
+	case NE_EXPR:
+	case GT_EXPR:
+	case LT_EXPR:
+	  return tristate::TS_FALSE;
+
+	default:
+	  /* For other ops, use the logic below.  */
+	  break;
 	}
+    }
 
-      /* If we have a pair of region_svalues, compare them.  */
-      if (region_svalue *lhs_ptr = lhs->dyn_cast_region_svalue ())
-	if (region_svalue *rhs_ptr = rhs->dyn_cast_region_svalue ())
-	  {
-	    tristate res = region_svalue::eval_condition (lhs_ptr, op, rhs_ptr);
-	    if (res.is_known ())
-	      return res;
-	    /* Otherwise, only known through constraints.  */
-	  }
+  /* If we have a pair of region_svalues, compare them.  */
+  if (const region_svalue *lhs_ptr = lhs->dyn_cast_region_svalue ())
+    if (const region_svalue *rhs_ptr = rhs->dyn_cast_region_svalue ())
+      {
+	tristate res = region_svalue::eval_condition (lhs_ptr, op, rhs_ptr);
+	if (res.is_known ())
+	  return res;
+	/* Otherwise, only known through constraints.  */
+      }
 
-      /* If we have a pair of constants, compare them.  */
-      if (constant_svalue *cst_lhs = lhs->dyn_cast_constant_svalue ())
-	if (constant_svalue *cst_rhs = rhs->dyn_cast_constant_svalue ())
-	  return constant_svalue::eval_condition (cst_lhs, op, cst_rhs);
+  /* If we have a pair of constants, compare them.  */
+  if (const constant_svalue *cst_lhs = lhs->dyn_cast_constant_svalue ())
+    if (const constant_svalue *cst_rhs = rhs->dyn_cast_constant_svalue ())
+      return constant_svalue::eval_condition (cst_lhs, op, cst_rhs);
 
-      /* Handle comparison of a region_svalue against zero.  */
-      if (region_svalue *ptr = lhs->dyn_cast_region_svalue ())
-	if (constant_svalue *cst_rhs = rhs->dyn_cast_constant_svalue ())
-	  if (zerop (cst_rhs->get_constant ()))
+  /* Handle comparison of a region_svalue against zero.  */
+
+  if (const region_svalue *ptr = lhs->dyn_cast_region_svalue ())
+    if (const constant_svalue *cst_rhs = rhs->dyn_cast_constant_svalue ())
+      if (zerop (cst_rhs->get_constant ()))
+	{
+	  /* A region_svalue is a non-NULL pointer, except in certain
+	     special cases (see the comment for region::non_null_p.  */
+	  const region *pointee = ptr->get_pointee ();
+	  if (pointee->non_null_p ())
 	    {
-	      /* A region_svalue is a non-NULL pointer, except in certain
-		 special cases (see the comment for region::non_null_p.  */
-	      region *pointee = get_region (ptr->get_pointee ());
-	      if (pointee->non_null_p (*this))
+	      switch (op)
 		{
-		  switch (op)
-		    {
-		    default:
-		      gcc_unreachable ();
-
-		    case EQ_EXPR:
-		    case GE_EXPR:
-		    case LE_EXPR:
-		      return tristate::TS_FALSE;
-
-		    case NE_EXPR:
-		    case GT_EXPR:
-		    case LT_EXPR:
-		      return tristate::TS_TRUE;
-		    }
+		default:
+		  gcc_unreachable ();
+
+		case EQ_EXPR:
+		case GE_EXPR:
+		case LE_EXPR:
+		  return tristate::TS_FALSE;
+
+		case NE_EXPR:
+		case GT_EXPR:
+		case LT_EXPR:
+		  return tristate::TS_TRUE;
 		}
 	    }
+	}
+
+  /* Handle rejection of equality for comparisons of the initial values of
+     "external" values (such as params) with the address of locals.  */
+  if (const initial_svalue *init_lhs = lhs->dyn_cast_initial_svalue ())
+    if (const region_svalue *rhs_ptr = rhs->dyn_cast_region_svalue ())
+      {
+	tristate res = compare_initial_and_pointer (init_lhs, rhs_ptr);
+	if (res.is_known ())
+	  return res;
+      }
+  if (const initial_svalue *init_rhs = rhs->dyn_cast_initial_svalue ())
+    if (const region_svalue *lhs_ptr = lhs->dyn_cast_region_svalue ())
+      {
+	tristate res = compare_initial_and_pointer (init_rhs, lhs_ptr);
+	if (res.is_known ())
+	  return res;
+      }
+
+  if (const widening_svalue *widen_lhs = lhs->dyn_cast_widening_svalue ())
+    if (tree rhs_cst = rhs->maybe_get_constant ())
+      {
+	tristate res = widen_lhs->eval_condition_without_cm (op, rhs_cst);
+	if (res.is_known ())
+	  return res;
+      }
+
+  return tristate::TS_UNKNOWN;
+}
+
+/* Subroutine of region_model::eval_condition_without_cm, for rejecting
+   equality of INIT_VAL(PARM) with &LOCAL.  */
+
+tristate
+region_model::compare_initial_and_pointer (const initial_svalue *init,
+					    const region_svalue *ptr) const
+{
+  const region *pointee = ptr->get_pointee ();
+
+  /* If we have a pointer to something within a stack frame, it can't be the
+     initial value of a param.  */
+  if (pointee->maybe_get_frame_region ())
+    {
+      const region *reg = init->get_region ();
+      if (tree reg_decl = reg->maybe_get_decl ())
+	if (TREE_CODE (reg_decl) == SSA_NAME)
+	  {
+	    tree ssa_name = reg_decl;
+	    if (SSA_NAME_IS_DEFAULT_DEF (ssa_name)
+		&& SSA_NAME_VAR (ssa_name)
+		&& TREE_CODE (SSA_NAME_VAR (ssa_name)) == PARM_DECL)
+	      return tristate::TS_FALSE;
+	  }
     }
 
   return tristate::TS_UNKNOWN;
@@ -5621,10 +1611,10 @@ region_model::add_constraint (tree lhs, enum tree_code op, tree rhs,
   if (FLOAT_TYPE_P (TREE_TYPE (lhs)) || FLOAT_TYPE_P (TREE_TYPE (rhs)))
     return true;
 
-  svalue_id lhs_sid = get_rvalue (lhs, ctxt);
-  svalue_id rhs_sid = get_rvalue (rhs, ctxt);
+  const svalue *lhs_sval = get_rvalue (lhs, ctxt);
+  const svalue *rhs_sval = get_rvalue (rhs, ctxt);
 
-  tristate t_cond = eval_condition (lhs_sid, op, rhs_sid);
+  tristate t_cond = eval_condition (lhs_sval, op, rhs_sval);
 
   /* If we already have the condition, do nothing.  */
   if (t_cond.is_true ())
@@ -5636,20 +1626,10 @@ region_model::add_constraint (tree lhs, enum tree_code op, tree rhs,
     return false;
 
   /* Store the constraint.  */
-  m_constraints->add_constraint (lhs_sid, op, rhs_sid);
+  m_constraints->add_constraint (lhs_sval, op, rhs_sval);
 
   add_any_constraints_from_ssa_def_stmt (lhs, op, rhs, ctxt);
 
-  /* If we now know a symbolic_region is non-NULL, clear its
-     m_possibly_null.  */
-  if (zerop (rhs) && op == NE_EXPR)
-    if (region_svalue *ptr = get_svalue (lhs_sid)->dyn_cast_region_svalue ())
-      {
-	region *pointee = get_region (ptr->get_pointee ());
-	if (symbolic_region *sym_reg = pointee->dyn_cast_symbolic_region ())
-	  sym_reg->m_possibly_null = false;
-      }
-
   /* Notify the context, if any.  This exists so that the state machines
      in a program_state can be notified about the condition, and so can
      set sm-state for e.g. unchecked->checked, both for cfg-edges, and
